using System;

namespace _01_Niz
{
    class Program
    {
        static void Main(string[] args)
        {
            string[] ulaz1 = Console.ReadLine().Split();
            int N = int.Parse(ulaz1[0]);
            int C = int.Parse(ulaz1[1]);
            int Q = int.Parse(ulaz1[2]);
            string S = Console.ReadLine();
            bool[] niz = new bool[N];
            for (int i = 0; i < S.Length; i++)
            {
                if (S[i]=='1')
                {
                    niz[i] = true;
                }
            }
            int[] izlazi = new int[Q];
            int L, R;
            string[] ulazi;
            for (int i = 0; i < Q; i++)
            {
                ulazi = Console.ReadLine().Split();
                L = int.Parse(ulazi[0]);
                R = int.Parse(ulazi[1]);
                for (int j = L-1; j < R; j++)
                {
                    niz[j] = !niz[j];
                }
                if (C==N)
                {
                    int brojNula = 0, brojJedinica = 0;
                    for (int k = 0; k < niz.Length; k++)
                    {
                        if (niz[k])
                        {
                            brojJedinica++;
                        }
                        else
                        {
                            brojNula++;
                        }
                    }
                    if (brojNula>0)
                    {
                        izlazi[i] = brojJedinica;
                    }
                    else
                    {
                        izlazi[i] = C;
                    }
                }
                else if (C==1)
                {
                    bool predhodni = niz[0];
                    for (int j = 1; j < N; j++)
                    {
                        if (predhodni && niz[j] == false)
                        {
                            izlazi[i]++;
                        }
                        predhodni = niz[j];
                    }
                    if (niz[N-1])
                    {
                        izlazi[i]++;
                    }
                }
            }
            for (int i = 0; i < Q; i++)
            {
                Console.WriteLine(izlazi[i]);
            }
        }
    }
}